Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Swing 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.swing.text
Class ParagraphView

    java.lang.Object
      |
      +--javax.swing.text.View
            |
            +--javax.swing.text.CompositeView
                  |
                  +--javax.swing.text.BoxView
                        |
                        +--javax.swing.text.ParagraphView

Direct Known Subclasses:
  ParagraphView

public class ParagraphView
extends BoxView
implements TabExpander

View of a simple line-wrapping paragraph that supports multiple fonts, colors, components, icons, etc. It is basically a vertical box with a margin around it. The contents of the box are a bunch of rows which are special horizontal boxes. This view creates a collection of views that represent the child elements of the paragraph element. Each of these views are placed into a row directly if they will fit, otherwise the `breakView` method is called to try and carve the view into pieces that fit.

See Also:
  `View`

Field Summary
`protected int` | `firstLineIndent` Indentation for the first line, from the left inset.

Fields inherited from class javax.swing.text.View
`BadBreakWeight, ExcellentBreakWeight, ForcedBreakWeight, GoodBreakWeight, X_AXIS, Y_AXIS`

Constructor Summary
`ParagraphView(Element elem)` Constructs a ParagraphView for the given element.

Method Summary
`protected void` | `adjustRow(javax.swing.text.ParagraphView.Row r, int desiredSpan, int x)` Adjusts the given row if possible to fit within the layout span.
`View` | `breakView(int axis, float len, java.awt.Shape a)` Breaks this view on the given axis at the given length. ParagraphView instances are breakable along the Y_AXIS only, and only if `len` is after the first line.
`protected SizeRequirements` | `calculateMinorAxisRequirements(int axis, SizeRequirements r)`
`void` | `changedUpdate(DocumentEvent changes, java.awt.Shape a, ViewFactory f)` Gives notification from the document that attributes were changed in a location that this view is responsible for.
`protected int` | `findOffsetToCharactersInString(char[] string, int start)` Finds the next character in the document with a character in `string`, starting at offset `start`.
`protected boolean` | `flipEastAndWestAtEnds(int position, Position.Bias bias)`
`float` | `getAlignment(int axis)` Determines the desired alignment for this view along an axis.
`int` | `getBreakWeight(int axis, float len)` Gets the break weight for a given location.
`protected int` | `getClosestPositionTo(int pos, Position.Bias b, java.awt.Shape a, int direction, Position.Bias[] biasRet, int rowIndex, int x)` Returns the closest model position to `x`.
`protected View` | `getLayoutView(int index)` The child views of the paragraph are rows which have been used to arrange pieces of the Views that represent the child elements.
`protected int` | `getLayoutViewCount()` The child views of the paragraph are rows which have been used to arrange pieces of the Views that represent the child elements.
`protected int` | `getNextNorthSouthVisualPositionFrom(int pos, Position.Bias b, java.awt.Shape a, int direction, Position.Bias[] biasRet)` Overriden from CompositeView.
`protected float` | `getPartialSize(int startOffset, int endOffset)` Returns the size used by the views between `startOffset` and `endOffset`.
`protected float` | `getTabBase()`
`protected TabSet` | `getTabSet()` Gets the Tabset to be used in calculating tabs.
`protected View` | `getViewAtPosition(int pos, java.awt.Rectangle a)` Fetches the child view that represents the given position in the model.
`protected int` | `getViewIndexAtPosition(int pos)` Fetches the child view index representing the given position in the model.
`void` | `insertUpdate(DocumentEvent changes, java.awt.Shape a, ViewFactory f)` Gives notification that something was inserted into the document in a location that this view is responsible for.
`protected void` | `layout(int width, int height)` Lays out the children.
`protected void` | `loadChildren(ViewFactory f)` Loads all of the children to initialize the view.
`float` | `nextTabStop(float x, int tabOffset)` Returns the next tab stop position given a reference position.
`void` | `paint(java.awt.Graphics g, java.awt.Shape a)` Renders using the given rendering surface and area on that surface.
`void` | `removeUpdate(DocumentEvent changes, java.awt.Shape a, ViewFactory f)` Gives notification that something was removed from the document in a location that this view is responsible for.
`protected void` | `setFirstLineIndent(float fi)` Set the indent on the first line
`protected void` | `setJustification(int j)` Set the type of justification.
`protected void` | `setLineSpacing(float ls)` Set the line spacing.
`protected void` | `setPropertiesFromAttributes()`

Methods inherited from class javax.swing.text.BoxView
`baselineLayout, baselineRequirements, calculateMajorAxisRequirements, childAllocation, getHeight, getMaximumSpan, getMinimumSpan, getOffset, getPreferredSpan, getResizeWeight, getSpan, getViewAtPoint, getWidth, isAfter, isAllocationValid, isBefore, layoutMajorAxis, layoutMinorAxis, modelToView, paintChild, preferenceChanged, replace, setSize, viewToModel`

Methods inherited from class javax.swing.text.CompositeView
`append, getBottomInset, getChildAllocation, getInsideAllocation, getLeftInset, getNextEastWestVisualPositionFrom, getNextVisualPositionFrom, getRightInset, getTopInset, getView, getViewCount, insert, modelToView, removeAll, setInsets, setParagraphInsets, setParent`

Methods inherited from class javax.swing.text.View
`breakView, createFragment, getAttributes, getBreakWeight, getContainer, getDocument, getElement, getEndOffset, getParent, getStartOffset, getViewFactory, isVisible, modelToView, viewToModel`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### firstLineIndent

    protected int firstLineIndent

  Indentation for the first line, from the left inset.

Constructor Detail

### ParagraphView

    public ParagraphView(Element elem)

  Constructs a ParagraphView for the given element.
  Parameters:
    `elem` - the element that this view is responsible for

Method Detail

### setJustification

    protected void setJustification(int j)

  Set the type of justification.

### setLineSpacing

    protected void setLineSpacing(float ls)

  Set the line spacing.
  Parameters:
    `ls` - the value in points

### setFirstLineIndent

    protected void setFirstLineIndent(float fi)

  Set the indent on the first line
  Parameters:
    `ls` - the value in points

### setPropertiesFromAttributes

    protected void setPropertiesFromAttributes()

### getLayoutViewCount

    protected int getLayoutViewCount()

  The child views of the paragraph are rows which have been used to arrange pieces of the Views that represent the child elements. This is the number of views that have been tiled in two dimensions, and should be equivalent to the number of child elements to the element this view is responsible for.

### getLayoutView

    protected View getLayoutView(int index)

  The child views of the paragraph are rows which have been used to arrange pieces of the Views that represent the child elements. This methods returns the view responsible for the child element index (prior to breaking). These are the Views that were produced from a factory (to represent the child elements) and used for layout.

### loadChildren

    protected void loadChildren(ViewFactory f)

  Loads all of the children to initialize the view. This is called by the `setParent` method. This is reimplemented to not load any children directly (as they are created in the process of formatting). This does create views to represent the child elements, but they are placed into a pool that is used in the process of formatting.
  Parameters:
    `f` - the view factory
  Overrides:
    loadChildren in class CompositeView

### getViewAtPosition

    protected View getViewAtPosition(int pos,
                                     java.awt.Rectangle a)

  Fetches the child view that represents the given position in the model. This is implemented to walk through the children looking for a range that contains the given position. In this view the children do not have a one to one mapping with the child elements (i.e. the children are actually rows that represent a portion of the element this view represents).
  Parameters:
    `pos` - the search position >= 0
    `a` - the allocation to the box on entry, and the allocation of the view containing the position on exit
  Overrides:
    getViewAtPosition in class CompositeView

### getViewIndexAtPosition

    protected int getViewIndexAtPosition(int pos)

  Fetches the child view index representing the given position in the model.
  Parameters:
    `pos` - the position >= 0
  Overrides:
    getViewIndexAtPosition in class CompositeView

### layout

    protected void layout(int width,
                          int height)

  Lays out the children. If the layout span has changed, the rows are rebuilt. The superclass functionality is called after checking and possibly rebuilding the rows. If the height has changed, the `preferenceChanged` method is called on the parent since the vertical preference is rigid.
  Parameters:
    `width` - the width to lay out against >= 0. This is the width inside of the inset area.
    `height` - the height to lay out against >= 0 (not used by paragraph, but used by the superclass). This is the height inside of the inset area.
  Overrides:
    layout in class BoxView

### adjustRow

    protected void adjustRow(javax.swing.text.ParagraphView.Row r,
                             int desiredSpan,
                             int x)

  Adjusts the given row if possible to fit within the layout span. By default this will try to find the highest break weight possible nearest the end of the row. If a forced break is encountered, the break will be positioned there.
  Parameters:
    `r` - the row to adjust to the current layout span.
    `desiredSpan` - the current layout span >= 0
    `x` - the location r starts at.

### nextTabStop

    public float nextTabStop(float x,
                             int tabOffset)

  Returns the next tab stop position given a reference position. This view implements the tab coordinate system, and calls `getTabbedSpan` on the logical children in the process of layout to determine the desired span of the children. The logical children can delegate their tab expansion upward to the paragraph which knows how to expand tabs. `LabelView` is an example of a view that delegates its tab expansion needs upward to the paragraph.

  This is implemented to try and locate a `TabSet` in the paragraph element's attribute set. If one can be found, its settings will be used, otherwise a default expansion will be provided. The base location for for tab expansion is the left inset from the paragraphs most recent allocation (which is what the layout of the children is based upon).

  Specified by:
    nextTabStop in interface TabExpander
  Parameters:
    `x` - the X reference position
    `tabOffset` - the position within the text stream that the tab occurred at >= 0.
  Returns:
    the trailing end of the tab expansion >= 0
  See Also:
    `TabSet`, `TabStop`, `LabelView`

### getTabSet

    protected TabSet getTabSet()

  Gets the Tabset to be used in calculating tabs.
  Returns:
    the TabSet

### getPartialSize

    protected float getPartialSize(int startOffset,
                                   int endOffset)

  Returns the size used by the views between `startOffset` and `endOffset`. This uses getPartialView to calculate the size if the child view implements the TabableView interface. If a size is needed and a View does not implement the TabableView interface, the preferredSpan will be used.
  Parameters:
    `startOffset` - the starting document offset >= 0
    `endOffset` - the ending document offset >= startOffset
  Returns:
    the size >= 0

### findOffsetToCharactersInString

    protected int findOffsetToCharactersInString(char[] string,
                                                 int start)

  Finds the next character in the document with a character in `string`, starting at offset `start`. If there are no characters found, -1 will be returned.
  Parameters:
    `string` - the string of characters
    `start` - where to start in the model >= 0
  Returns:
    the document offset or -1

### getTabBase

    protected float getTabBase()

  Returns:
    where tabs are calculated from.

### flipEastAndWestAtEnds

    protected boolean flipEastAndWestAtEnds(int position,
                                            Position.Bias bias)

  Overrides:
    flipEastAndWestAtEnds in class BoxView

### paint

    public void paint(java.awt.Graphics g,
                      java.awt.Shape a)

  Renders using the given rendering surface and area on that surface. This is implemented to delgate to the superclass after stashing the base coordinate for tab calculations.
  Parameters:
    `g` - the rendering surface to use
    `a` - the allocated region to render into
  Overrides:
    paint in class BoxView
  See Also:
    `View.paint(java.awt.Graphics, java.awt.Shape)`

### calculateMinorAxisRequirements

    protected SizeRequirements calculateMinorAxisRequirements(int axis,
                                                              SizeRequirements r)

  Overrides:
    calculateMinorAxisRequirements in class BoxView

### getAlignment

    public float getAlignment(int axis)

  Determines the desired alignment for this view along an axis. This is implemented to give the alignment to the center of the first row along the y axis, and the default along the x axis.
  Parameters:
    `axis` - may be either View.X_AXIS or View.Y_AXIS
  Overrides:
    getAlignment in class BoxView

### breakView

    public View breakView(int axis,
                          float len,
                          java.awt.Shape a)

  Breaks this view on the given axis at the given length.

  ParagraphView instances are breakable along the Y_AXIS only, and only if `len` is after the first line.

  Parameters:
    `axis` - may be either View.X_AXIS or View.Y_AXIS
    `len` - specifies where a potential break is desired along the given axis >= 0
    `a` - the current allocation of the view
  Returns:
    the fragment of the view that represents the given span, if the view can be broken. If the view doesn't support breaking behavior, the view itself is returned.
  See Also:
    `View.breakView(int, int, float, float)`

### getBreakWeight

    public int getBreakWeight(int axis,
                              float len)

  Gets the break weight for a given location. ParagraphView instances are breakable along the Y_AXIS only, and only if `len` is after the first row. If the length is less than one row, a value of BadBreakWeight is returned.
  Parameters:
    `axis` - may be either View.X_AXIS or View.Y_AXIS
    `len` - specifies where a potential break is desired >= 0
  Returns:
    a value indicating the attractiveness of breaking here
  See Also:
    `View.getBreakWeight(int, float, float)`

### insertUpdate

    public void insertUpdate(DocumentEvent changes,
                             java.awt.Shape a,
                             ViewFactory f)

  Gives notification that something was inserted into the document in a location that this view is responsible for.
  Parameters:
    `changes` - the change information from the associated document
    `a` - the current allocation of the view
    `f` - the factory to use to rebuild if the view has children
  Overrides:
    insertUpdate in class BoxView
  See Also:
    `View.insertUpdate(javax.swing.event.DocumentEvent, java.awt.Shape, javax.swing.text.ViewFactory)`

### removeUpdate

    public void removeUpdate(DocumentEvent changes,
                             java.awt.Shape a,
                             ViewFactory f)

  Gives notification that something was removed from the document in a location that this view is responsible for.
  Parameters:
    `changes` - the change information from the associated document
    `a` - the current allocation of the view
    `f` - the factory to use to rebuild if the view has children
  Overrides:
    removeUpdate in class BoxView
  See Also:
    `View.removeUpdate(javax.swing.event.DocumentEvent, java.awt.Shape, javax.swing.text.ViewFactory)`

### changedUpdate

    public void changedUpdate(DocumentEvent changes,
                              java.awt.Shape a,
                              ViewFactory f)

  Gives notification from the document that attributes were changed in a location that this view is responsible for.
  Parameters:
    `changes` - the change information from the associated document
    `a` - the current allocation of the view
    `f` - the factory to use to rebuild if the view has children
  Overrides:
    changedUpdate in class BoxView
  See Also:
    `View.changedUpdate(javax.swing.event.DocumentEvent, java.awt.Shape, javax.swing.text.ViewFactory)`

### getNextNorthSouthVisualPositionFrom

    protected int getNextNorthSouthVisualPositionFrom(int pos,
                                                      Position.Bias b,
                                                      java.awt.Shape a,
                                                      int direction,
                                                      Position.Bias[] biasRet)
                                               throws BadLocationException

  Overriden from CompositeView.
  Overrides:
    getNextNorthSouthVisualPositionFrom in class CompositeView

### getClosestPositionTo

    protected int getClosestPositionTo(int pos,
                                       Position.Bias b,
                                       java.awt.Shape a,
                                       int direction,
                                       Position.Bias[] biasRet,
                                       int rowIndex,
                                       int x)
                                throws BadLocationException

  Returns the closest model position to `x`. `rowIndex` gives the index of the view that corresponds that should be looked in.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Swing 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
Java is a trademark or registered trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-1998 Sun Microsystems, Inc. 901 San Antonio Road,
Palo Alto, California, 94303, U.S.A. All Rights Reserved.